<?php

if ( !ereg( 'plugins_page.php', $_SERVER['REQUEST_URI'] ) ) {
    header( 'Location: ../../plugins_page.php' );
    exit();
}

auth_ensure_user_authenticated();

$t_current_user_id = auth_get_current_user_id();

if ( !user_is_administrator( $t_current_user_id ) ) {
    header( 'Location: index.php' );
    exit();
}

$t_PLUGINS_WEEKLY_VIEW_BOXES_DEFAULT = array( 'unassigned' => '1,on', 'resolved' => '2,on', 'recent_mod' => '3,on', 'feedback' => '0,on', 'verify' => '0,on' );


$t_action = gpc_get_string( 'action', 'none' );
if ( $t_action == 'update' ) {
    $t_project_id = gpc_get_int( 'project_id' );
    $t_enable = gpc_get_bool( 'enable' );
    $t_html_enable = gpc_get_bool( 'html_enable' );
    $t_html_host = gpc_get_string( 'html_host', '' );
    $t_format = gpc_get_int( 'format' );
    $t_subject = gpc_get_string( 'subject' );
    $t_user_ids = gpc_get_int_array( 'user_id' );
    $t_end = gpc_get_int( 'end' );
    $t_period = gpc_get_int( 'period' );
    $t_boxes['unassigned'] = gpc_get_int( 'unassigned' ) . ',';
    if ( gpc_get_bool( 'unassigned_use_date' ) ) {
        $t_boxes['unassigned'] .= 'on';
    } else {
        $t_boxes['unassigned'] .= 'off';
    }
    $t_boxes['resolved'] = gpc_get_int( 'resolved' ) . ',';
    if ( gpc_get_bool( 'resolved_use_date' ) ) {
        $t_boxes['resolved'] .= 'on';
    } else {
        $t_boxes['resolved'] .= 'off';
    }
    $t_boxes['recent_mod'] = gpc_get_int( 'recent_mod' ) . ',';
    if ( gpc_get_bool( 'recent_mod_use_date' ) ) {
        $t_boxes['recent_mod'] .= 'on';
    } else {
        $t_boxes['recent_mod'] .= 'off';
    }
    $t_boxes['feedback'] = gpc_get_int( 'feedback' ) . ',';
    if ( gpc_get_bool( 'feedback_use_date' ) ) {
        $t_boxes['feedback'] .= 'on';
    } else {
        $t_boxes['feedback'] .= 'off';
    }
    $t_boxes['verify'] = gpc_get_int( 'verify' ) . ',';
    if ( gpc_get_bool( 'verify_use_date' ) ) {
        $t_boxes['verify'] .= 'on';
    } else {
        $t_boxes['verify'] .= 'off';
    }
    $t_bug_number = gpc_get_int( 'bug_number' );
    config_set( 'plugins_weekly_enable', $t_enable, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_html_enable', $t_html_enable, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_html_host', $t_html_host, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_format', $t_format, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_subject_title', $t_subject, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_users', $t_user_ids, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_end', $t_end, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_period', $t_period, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_bug_number', $t_bug_number, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_view_boxes', $t_boxes, NO_USER, $t_project_id );
    header( 'Location: plugins_page.php?plugin=weekly' );
    exit();
}

$t_project_id = helper_get_current_project();

$t_lang = user_pref_get_language( $t_current_user_id, helper_get_current_project() );
$t_lang_file = dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'lang' . DIRECTORY_SEPARATOR . 'strings_' . $t_lang . '.txt';
if ( file_exists( $t_lang_file ) ) {
    require_once( $t_lang_file );
} else {
    $t_lang_file = dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'lang' . DIRECTORY_SEPARATOR . 'strings_english.txt';
    require_once( $t_lang_file );
}
$t_vars = get_defined_vars();

foreach ( array_keys( $t_vars ) as $t_var ) {
    $t_lang_var = ereg_replace( '^s_', '', $t_var );
    if ( $t_lang_var != $t_var && ereg( 'plugins_weekly_', $t_lang_var ) ) {
        $g_lang_strings[$t_lang][$t_lang_var] = $$t_var;
    }
}

function print_user_list( $p_user_ids ) {
    $t_mantis_project_user_list_table = config_get( 'mantis_project_user_list_table' );
    $t_mantis_user_table = config_get( 'mantis_user_table' );
    
    $query = "SELECT DISTINCT u.id, u.username, u.realname
				FROM $t_mantis_user_table u
				LEFT JOIN $t_mantis_project_user_list_table p
				ON p.user_id=u.id AND p.project_id='0'
				WHERE 	u.enabled = 1 AND
					p.user_id IS NULL
				ORDER BY u.realname, u.username";
    $result = db_query( $query );
    $t_display = array();
    $t_sort = array();
    $t_users = array();
    $t_show_realname = ( ON == config_get( 'show_realname' ) );
    $t_sort_by_last_name = ( ON == config_get( 'sort_by_last_name' ) );
    $category_count = db_num_rows( $result );
    for ($i=0;$i<$category_count;$i++) {
        $row = db_fetch_array( $result );
        $t_users[] = $row['id'];
        $t_user_name = string_attribute( $row['username'] );
        $t_sort_name = $t_user_name;
        if ( ( isset( $row['realname'] ) ) && ( $row['realname'] <> "" ) && $t_show_realname ) {
            $t_user_name = string_attribute( $row['realname'] );
            if ( $t_sort_by_last_name ) {
                $t_sort_name_bits = split( ' ', strtolower( $t_user_name ), 2 );
                $t_sort_name = ( isset( $t_sort_name_bits[1] ) ? $t_sort_name_bits[1] . ', ' : '' ) . $t_sort_name_bits[0];
            } else {
                $t_sort_name = strtolower( $t_user_name );
            }
        }
        $t_display[] = $t_user_name;
        $t_sort[] = $t_sort_name;
    }
    array_multisort( $t_sort, SORT_ASC, SORT_STRING, $t_users, $t_display );
    for ($i = 0; $i < count( $t_sort ); $i++ ) {
        echo '<option value="' . $t_users[$i] . '"';
        if ( in_array( $t_users[$i], $p_user_ids ) ) {
            echo ' selected="selected"';
        }       
        echo '>' . $t_display[$i] . '</option>';
    }
}

$t_boxes = config_get( 'plugins_weekly_view_boxes', $t_PLUGINS_WEEKLY_VIEW_BOXES_DEFAULT );
$t_box = array();
foreach( $t_boxes as $t_key => $t_value ) {
    $t_value = explode( ',', $t_value );
    $t_box[$t_key]['position'] = $t_value[0];
    $t_box[$t_key]['use_date'] = $t_value[1];
}

html_page_top1( 'Weekly Plugin configuration' );
html_page_top2();

?>

<br />
<div align="center">
<?php

  echo str_replace( '%%project%%', '<b>' . project_get_name( helper_get_current_project() ) . '</b>', lang_get( 'plugins_weekly_configuration_for_project' ) );

?>
<br /><br />
<form name="plugins_weekly" method="post" action="plugins_page.php">
<input type="hidden" name="action" value="update" />
<input type="hidden" name="project_id" value="<?php echo $t_project_id ?>" />
<input type="hidden" name="plugin" value="weekly" />
<table class="width75" cellspacing="1">

<!-- Enable/Disable -->
<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_enable' ) ?>
</td>
<td width="70%">
<input tabindex="1" type="checkbox" name="enable"<?php check_checked( config_get( 'plugins_weekly_enable', OFF ), ON ) ?> />
</td>
</tr>

<!-- spacer -->
<tr>
<td class="spacer" colspan="2">&nbsp;</td>
</tr>

<!-- Send by browsing -->
<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_allow_sending_by_html' ) ?>
</td>
<td width="70%">
<input tabindex="2" type="checkbox" name="html_enable"<?php check_checked( config_get( 'plugins_weekly_html_enable', OFF ), ON ) ?> />
</td>
</tr>

<!-- From host -->
<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<?php echo lang_get( 'plugins_weekly_from_host' ) ?>
</td>
<td width="70%">
<input tabindex="3" type="input" name="html_host" value="<?php echo config_get( 'plugins_weekly_html_host', '' ) ?>" />
</td>
</tr>

<!-- spacer -->
<tr>
<td class="spacer" colspan="2">&nbsp;</td>
</tr>

<!-- Format -->
<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_format' ) ?>
</td>
<td width="70%">
<select tabindex="4" name="format">
<option value="0"<?php check_selected( config_get( 'plugins_weekly_format', 0 ), 0 ) ?>>Text</option>
<option value="1"<?php check_selected( config_get( 'plugins_weekly_format', 0 ), 1 ) ?>>HTML (<?php echo lang_get( 'plugins_weekly_not_recommended' ) ?>)</option>
<option value="2"<?php check_selected( config_get( 'plugins_weekly_format', 0 ), 2 ) ?>>Text/HTML</option>
</select>
</td>
</tr>

<!-- spacer -->
<tr>
<td class="spacer" colspan="2">&nbsp;</td>
</tr>

<!-- Subject -->
<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_email_subject' ) ?>
</td>
<td width="70%">
<input tabindex="5" type="input" name="subject" size="50" value="<?php echo config_get( 'plugins_weekly_subject_title', 'Bugtracker weekly report' ) ?>" />
</td>
</tr>

<!-- End -->
<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_offset' ) ?>
</td>
<td width="70%">
<input tabindex="6" type="input" name="end" size="4" value="<?php echo config_get( 'plugins_weekly_end', 1 ) ?>" /> <?php echo lang_get( 'plugins_weekly_hours' ) ?>
</td>
</tr>

<!-- Period -->
<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_period' ) ?>
</td>
<td width="70%">
<input tabindex="7" type="input" name="period" size="4" value="<?php echo config_get( 'plugins_weekly_period', 7 ) ?>" /> <?php echo lang_get( 'plugins_weekly_days' ) ?>
</td>
</tr>

<!-- spacer -->
<tr>
<td class="spacer" colspan="2">&nbsp;</td>
</tr>

<!-- View boxes -->
<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_unassigned' ) ?>
</td>
<td width="70%">
<input tabindex="8" type="input" name="unassigned" size="4" value="<?php echo $t_box['unassigned']['position'] ?>" />
<input tabindex="9" type="checkbox" name="unassigned_use_date"<?php check_checked( $t_box['unassigned']['use_date'], 'on' ) ?> /> <?php echo lang_get( 'plugins_weekly_use_date_filter' ) ?>
</td>
</tr>

<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_resolved' ) ?>
</td>
<td width="70%">
<input tabindex="10" type="input" name="resolved" size="4" value="<?php echo $t_box['resolved']['position'] ?>" />
<input tabindex="11" type="checkbox" name="resolved_use_date"<?php check_checked( $t_box['resolved']['use_date'], 'on' ) ?> /> <?php echo lang_get( 'plugins_weekly_use_date_filter' ) ?>
</td>
</tr>

<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_recently_modified' ) ?>
</td>
<td width="70%">
<input tabindex="12" type="input" name="recent_mod" size="4" value="<?php echo $t_box['recent_mod']['position'] ?>" />
<input tabindex="13" type="checkbox" name="recent_mod_use_date"<?php check_checked( $t_box['recent_mod']['use_date'], 'on' ) ?> /> <?php echo lang_get( 'plugins_weekly_use_date_filter' ) ?>
</td>
</tr>

<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_feedback' ) ?>
</td>
<td width="70%">
<input tabindex="14" type="input" name="feedback" size="4" value="<?php echo $t_box['feedback']['position'] ?>" />
<input tabindex="15" type="checkbox" name="feedback_use_date"<?php check_checked( $t_box['feedback']['use_date'], 'on' ) ?> /> <?php echo lang_get( 'plugins_weekly_use_date_filter' ) ?>
</td>
</tr>

<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_verify' ) ?>
</td>
<td width="70%">
<input tabindex="16" type="input" name="verify" size="4" value="<?php echo $t_box['verify']['position'] ?>" />
<input tabindex="17" type="checkbox" name="verify_use_date"<?php check_checked( $t_box['verify']['use_date'], 'on' ) ?> /> <?php echo lang_get( 'plugins_weekly_use_date_filter' ) ?>
</td>
</tr>

<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_bug_count' ) ?>
</td>
<td width="70%">
<input tabindex="18" type="input" name="bug_number" size="4" value="<?php echo config_get( 'plugins_weekly_bug_number', 20 ) ?>" />
</td>
</tr>

<!-- spacer -->
<tr>
<td class="spacer" colspan="2">&nbsp;</td>
</tr>

<!-- Send to -->
<tr <?php echo helper_alternate_class() ?>>
<td class="category" width="30%">
<span class="required">*</span><?php echo lang_get( 'plugins_weekly_send_to' ) ?>
</td>
<td width="70%">
<select tabindex="19" name="user_id[]" multiple="multiple" size="10">
<?php print_user_list( config_get( 'plugins_weekly_users', array() ) ) ?>
</select>
</td>
</tr>

<!-- Submit Button -->
<tr>
<td class="left">
<span class="required"> * <?php echo lang_get( 'required' ) ?></span>
</td>
<td class="center">
<input tabindex="20" type="submit" class="button" value="<?php echo lang_get( 'submit_button' ) ?>" />
</td>
</tr>

</table>
</form>

</div>

<?php

html_page_bottom1( __FILE__ );

?>
