<?php

require_once( 'core.php' );

$t_plugin = gpc_get_string( 'plugin', 'none' );

if ( $t_plugin != 'none' ) {
    $t_index = 'plugins' . DIRECTORY_SEPARATOR . $t_plugin . DIRECTORY_SEPARATOR . 'index.php';
    if ( file_exists( $t_index ) ) {
        include( $t_index );
        exit();
    }
}

auth_ensure_user_authenticated();

$t_current_user_id = auth_get_current_user_id();

if ( !user_is_administrator( $t_current_user_id ) ) {
    header( 'Location: index.php' );
    exit();
}

html_page_top1( 'Plugins configuration' );
html_page_top2();

?>

<br />
<div align="center">

<table class="width75" cellspacing="1">

<!-- Title -->
<tr>
<td class="center">Plugin</td>
<td class="center"></td>
<td class="center">Installed Version</td>
<td class="center">Current Version</td>
</tr>

<?php

$t_dir = opendir( dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'plugins' );

while( ( $t_file = readdir( $t_dir ) ) !== false ) {
    if ( is_dir( dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'plugins' . DIRECTORY_SEPARATOR . $t_file ) && $t_file != '.' && $t_file != '..' ) {
        $t_plugin = $t_file;
        $t_file = dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'plugins' . DIRECTORY_SEPARATOR . $t_file . DIRECTORY_SEPARATOR . 'info.php';
        if ( file_exists( $t_file ) ) {
            include( $t_file );
            $t_function = $t_plugin . '_get_info';
            if ( function_exists( $t_function ) ) {
                $t_plugin_info = $t_function();
                echo '<tr ' . helper_alternate_class() . ">\n";
                echo '<td class="center"><b><a href="plugins_page.php?plugin=' . $t_plugin . '">' . $t_plugin_info['name'] . "</a></b></td>\n";
                echo '<td class="center">';
                if ( isset( $t_plugin_info['url'] ) ) {
                    echo '<a href="' . $t_plugin_info['url'] . '">www</a> [<a href="' . $t_plugin_info['url'] . '" target="_blank">^</a>]';
                }
                echo "</td>\n";
                echo '<td class="center">' . $t_plugin_info['version'] . "</td>\n";
                echo '<td class="center">';
                if ( isset( $t_plugin_info['check'] ) ) {
                    $t_url = @fopen( $t_plugin_info['check'], 'r' );
                    if ( $t_url ) {
                        $t_version = fscanf( $t_url, '%d.%d.%d\n' );
                        $t_version = implode( '.', $t_version );
                        if ( $t_version != $t_plugin_info['version'] ) {
                            echo '<b>' . $t_version . '</b>';
                        } else {
                            echo $t_version;
                        }
                        fclose( $t_url );
                    } else {
                        echo '-';
                    }
                } else {
                    echo '-';
                }
                echo "</td>\n";
                echo "</tr>\n";
            }
        }
    }
}

closedir( $t_dir );

?>


</table>

</div>

<?php

html_page_bottom1( __FILE__ );

?>
